#include <math.h>

static double max(double a,double b) { return a>b ? a:b; }
static double min(double a,double b) { return a<b ? a:b; }

int main(int argc, const char* const *argv)
{
  int level,fear;
  
  int morale = 255;
  if(argc == 2) morale = atoi(argv[1]);

  printf("for morale=%d\n", morale);
  
  // minimi - tll 50-leveli alkaa jo saada jotain
  double minfear = (79 + (2*50) - 0 - morale) / -40.0;
  
  // maksimi - tll 1-levelikin alkaa saada "always"
  double maxfear = (80 + (2* 1) -51 - morale) / -40.0;
  
  int minf = (int)ceil(max(minfear, 0));
  int maxf = (int)floor(min(maxfear, minf+5));
  //printf("minfear=%.2f maxfear=%.2f minf=%d maxf=%d\n", minfear,maxfear, minf,maxf);
  
  if(maxf < minf)
  {
    printf("- the enemy will always run regardless of player level.\n");
  }
  else
  {
    printf("p-level");
    for(fear=minf; fear<=maxf; ++fear) printf("\tfear*%d", fear);
    printf("\n");
    for(level=1; level<=50; ++level)
    {
      printf("%d", level);
      for(fear=minf; fear<=maxf; ++fear)
      {
        // it happens, if
        //    255 - 40*fearcount - (2*level) + rand(0,50)  < 80
        
        int base = morale - 40*fear - 2*level;
        
        // 
        double rand_80 = 80-base;
        
        double chance = rand_80 / 50.0;
        if(chance < 0) chance=0;
        if(chance > 1) chance=1;
        
        if(chance <= 0.0)
          printf("\t-");
        else if(chance >= 1.0)
          printf("\talways");
        else
          printf("\t%.1f%%", chance*100.0);
      }
      printf("\n");
    }
  }
}
